#pragma once
#include "FP_tree.h"
#include <algorithm>

// Ӽ򻯵Ԫ鹹FP
static FPTree buildFPTree(const std::list<std::string>& transactions, const std::map<std::string, int>& itemSupport) {
    FPTree fptree;

    // ֶ֧Ƚе
    std::list<std::string> sortedItems;
    for (auto entry = itemSupport.begin(); entry != itemSupport.end(); entry++) {
        sortedItems.push_back(entry->first);
    }

    sortedItems.sort([itemSupport](std::string a, std::string b) {
        auto it_a = itemSupport.find(a);
        auto it_b = itemSupport.find(b);
        return it_a->second > it_b->second;
        });

    // ÿ񣬲뵽FP
    for (const std::string& transaction : transactions) {
        std::list<std::string> sortedTransaction;
        for (const std::string& item : sortedItems) {
            if (transaction.find(item) != std::string::npos) {
                sortedTransaction.push_back(item);
            }
        }
        fptree.insertTransaction(sortedTransaction, 1);
    }

    return fptree;
}