#pragma once
#include <iostream>
#include <string>
#include <list>
#include <map>
#include <memory>
// FPĽڵ
struct FPNode {
    std::string item;
    int count;
    std::shared_ptr<FPNode> parent;
    std::list<std::shared_ptr<FPNode>> children;

    // 캯
    FPNode(const std::string& itemName, int count, std::shared_ptr<FPNode> parentNode)
        : item(itemName), count(count), parent(parentNode) {}

    // ӽڵ
    std::shared_ptr<FPNode> findChild(const std::string& itemName) {
        for (const auto& child : children) {
            if (child->item == itemName) {
                return child;
            }
        }
        return nullptr;
    }
};

// FP
class FPTree {
public:
    FPTree() : root(std::make_shared<FPNode>("null", 0, nullptr)) {}

    // в
    void insertTransaction(const std::list<std::string>& transaction, int count) {
        std::shared_ptr<FPNode> currentNode = root;
        for (const std::string& item : transaction) {
            auto childNode = currentNode->findChild(item);
            if (childNode) {
                // ڵѴڣӼ
                childNode->count += count;
            }
            else {
                // ڵ㲻ڣ½ڵ
                auto newNode = std::make_shared<FPNode>(item, count, currentNode);
                currentNode->children.push_back(newNode);
                headerTable[item].push_back(newNode);
            }
            currentNode = currentNode->findChild(item);
        }
    }

    // ӡFP
    void printTree() const {
        printTreeRecursive(root, 0);
    }
   

private:
    // ݹӡFP
    void printTreeRecursive(const std::shared_ptr<FPNode>& node, int depth) const {
        for (int i = 0; i < depth; ++i) {
            std::cout << "  ";//־ͬһڵ

        }
        std::cout << node->item << " (" << node->count << ")\n";//ǰڵ

        for (const auto& child : node->children) {
            printTreeRecursive(child, depth + 1);
        }
    }

    // ڵ
    std::shared_ptr<FPNode> root;

    // ͷڱÿĵһڵ
    std::map<std::string, std::list<std::shared_ptr<FPNode>>> headerTable;

    // ĵһڵ
    std::shared_ptr<FPNode> findHeaderNode(const std::string& item) const {
        if (headerTable.find(item) != headerTable.end() && !headerTable.at(item).empty()) {
            return headerTable.at(item).front();
        }
        return nullptr;
    }

 



};

